
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>(原创)高性能IP数据库格式详解 qqzeng-ip.dat / 憋错料</title>

    <meta name="description" content="(原创)高性能IP数据库格式详解 qqzeng-ip.dat 高性能IP数据库格式详解 qqzeng-ip.dat 编码:UTF8           字节序:Little-Endian 返回多个字段信息(如:亚洲|中国|香港|九龙|油尖旺|新世界电讯|810200|Hong Kong|HK|114.17495|22.327115) ------------------------ 文件结构 --------------------------- //文件头 16字节(4-4-4-4) [索引区第一条流位置][索引区最后一条流位置][前缀区第一条的流位置]">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">(原创)高性能IP数据库格式详解 qqzeng-ip.dat</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<h2>高性能IP数据库格式详解 qqzeng-ip.dat</h2>
<p><strong> 编码：</strong>UTF8 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;&nbsp;<strong>字节序：</strong>Little-Endian</p>
<p><strong> 返回多个字段信息</strong>（如：亚洲|中国|香港|九龙|油尖旺|新世界电讯|810200|Hong Kong|HK|114.17495|22.327115）</p>
<p>------------------------ <strong>文件结构</strong> ---------------------------</p>
<p><strong>    //文件头</strong>    <strong>16</strong>字节(<strong>4-4-4-4</strong>)<br />    [索引区第一条流位置][索引区最后一条流位置][前缀区第一条的流位置][前缀区最后一条的流位置]</p>
<p><strong>    //内容区</strong>    长度无限制<br />    [地区信息][地区信息]&hellip;&hellip;唯一不重复</p>
<p><strong>    //索引区</strong>    <strong>12</strong>字节(<strong>4-4-3-1</strong>)<br />    [起始IP][结束IP][地区流位置][流长度]</p>
<p><strong>    //前缀区</strong>   <strong>9</strong>字节(<strong>1-4-4</strong>)<br />    [0-255][索引区start索引][索引区end索引]</p>
<p>------------------------ <strong>文件结构</strong> ---------------------------</p>
<p><strong>    优势：</strong>索引区分为[起始IP][结束IP][地区偏移][长度],减少多级偏移跳转步骤和长度的解析,提高效率;<br />         根据ip第一位字节作为前缀,解析出以这个数字为前缀的第一个索引和最后一个索引,缩小查询区间,<br />         然后在这区间再用二分查找快速查找到对应区间,效率提高几个等级</p>
<p><strong>    压缩：</strong>原版txt为15M,生成这种dat结构为2.45M</p>
<p><strong>    性能：</strong>普通电脑测试,解析，100万ip耗时2.012439秒，1千万耗时21.10258秒，好点的电脑测试会更高效</p>
<p><strong>    对比：</strong>相比其他dat更简洁更高效</p>
<p><strong>    创建：</strong>qqzeng-ip 于 2015-08-01</p>
<pre>public class IPSearch
{
    private Dictionary&lt;uint, PrefixIndex&gt; prefixDict;
    private byte[] indexBuffer;
    private byte[] data;
    long firstStartIpOffset;//索引区第一条流位置
    long lastStartIpOffset;//索引区最后一条流位置
    long prefixStartOffset;//前缀区第一条的流位置
    long prefixEndOffset;//前缀区最后一条的流位置
    long ipCount;       //ip段数量
    long prefixCount;  //前缀数量

    /// &lt;summary&gt;
    /// 初始化二进制dat数据
    /// &lt;/summary&gt;
    /// &lt;param name="dataPath"&gt;&lt;/param&gt;
    public IPSearch(string dataPath)
    {
        using (FileStream fs = new FileStream(dataPath, FileMode.Open, FileAccess.Read, FileShare.Read))
        {
            data = new byte[fs.Length];
            fs.Read(data, 0, data.Length);
        }

        firstStartIpOffset = BytesToLong(data[0], data[1], data[2], data[3]);
        lastStartIpOffset = BytesToLong(data[4], data[5], data[6], data[7]);
        prefixStartOffset = BytesToLong(data[8], data[9], data[10], data[11]);
        prefixEndOffset = BytesToLong(data[12], data[13], data[14], data[15]);

        //prefixCount 不固定为256 方便以后自由定制 国内版  国外版 全球版 或者某部分 都可以

        ipCount = (lastStartIpOffset - firstStartIpOffset) / 12 + 1; //索引区块每组 12字节
        prefixCount = (prefixEndOffset - prefixStartOffset) / 9 + 1; //前缀区块每组 9字节

        //初始化前缀对应索引区区间
        indexBuffer = new byte[prefixCount * 9];
        Array.Copy(data, prefixStartOffset, indexBuffer, 0, prefixCount * 9);
        prefixDict = new Dictionary&lt;uint, PrefixIndex&gt;();
        for (var k = 0; k &lt; prefixCount; k++)
        {
            int i = k * 9;
            uint prefix = (uint)indexBuffer[i];
            long start_index = BytesToLong(indexBuffer[i + 1], indexBuffer[i + 2], indexBuffer[i + 3], indexBuffer[i + 4]);
            long end_index = BytesToLong(indexBuffer[i + 5], indexBuffer[i + 6], indexBuffer[i + 7], indexBuffer[i + 8]);
            prefixDict.Add(prefix, new PrefixIndex() { prefix = prefix, start_index = start_index, end_index = end_index });
        }

    }

    public static uint IpToInt(string ip)
    {
        byte[] bytes = IPAddress.Parse(ip).GetAddressBytes();
        return (uint)bytes[3] + (((uint)bytes[2]) &lt;&lt; 8) + (((uint)bytes[1]) &lt;&lt; 16) + (((uint)bytes[0]) &lt;&lt; 24);
    }

    public static string IntToIP(uint ip_Int)
    {
        return new IPAddress(ip_Int).ToString();
    }

    /// &lt;summary&gt;
    /// 根据ip查询多维字段信息
    /// &lt;/summary&gt;
    /// &lt;param name="ip"&gt;ip地址（123.4.5.6）&lt;/param&gt;
    /// &lt;returns&gt;亚洲|中国|香港|九龙|油尖旺|新世界电讯|810200|Hong Kong|HK|114.17495|22.327115&lt;/returns&gt;
    public string Query(string ip)
    {
        uint intIP = IpToInt(ip);
        uint high = 0;
        uint low = 0;
        uint startIp = 0;
        uint endIp = 0;
        uint local_offset = 0;
        uint local_length = 0;

        uint ip_prefix_value = uint.Parse(ip.Split(‘.‘)[0]);
        if (prefixDict.ContainsKey(ip_prefix_value))
        {
            low = (uint)prefixDict[ip_prefix_value].start_index;
            high = (uint)prefixDict[ip_prefix_value].end_index;
        }
        else
        {
            return "";
        }

        uint my_index = low == high? low : BinarySearch(low, high, intIP);          

        GetIndex(my_index, out startIp, out endIp, out local_offset, out local_length);

        if ((startIp &lt;= intIP) &amp;&amp; (endIp &gt;= intIP))
        {
            return GetLocal(local_offset, local_length);
        }
        else
        {
            return "";
        }

    }
    /// &lt;summary&gt;
    /// 二分逼近算法
    /// &lt;/summary&gt;
    public uint BinarySearch(uint low, uint high, uint k)
    {
        uint M = 0;
        while (low &lt;= high)
        {
            uint mid = (low + high) / 2;

            uint endipNum = GetEndIp(mid);
            if (endipNum &gt;= k)
            {
                M = mid; //mid有可能是解
                high = mid - 1;
            }
            else
                low = mid + 1;
        }
        return M;
    }
    /// &lt;summary&gt;
    /// 在索引区解析
    /// &lt;/summary&gt;
    /// &lt;param name="left"&gt;ip第left个索引&lt;/param&gt;
    /// &lt;param name="startip"&gt;返回开始ip的数值&lt;/param&gt;
    /// &lt;param name="endip"&gt;返回结束ip的数值&lt;/param&gt;
    /// &lt;param name="local_offset"&gt;返回地址信息的流位置&lt;/param&gt;
    /// &lt;param name="local_length"&gt;返回地址信息的流长度&lt;/param&gt;
    private void GetIndex(uint left, out uint startip, out uint endip, out uint local_offset, out uint local_length)
    {
        long left_offset = firstStartIpOffset + (left * 12);
        startip = BytesToLong(data[left_offset], data[1 + left_offset], data[2 + left_offset],data[3 + left_offset]);
        endip = BytesToLong(data[4+left_offset], data[5 + left_offset], data[6 + left_offset], data[7 + left_offset]);
        local_offset = (uint)data[8 + left_offset] + (((uint)data[9 + left_offset]) &lt;&lt; 8) + (((uint)data[10 + left_offset]) &lt;&lt; 16);
        local_length = (uint)data[11 + left_offset];
    }
    /// &lt;summary&gt;
    /// 只获取结束ip的数值
    /// &lt;/summary&gt;
    /// &lt;param name="left"&gt;索引区第left个索引&lt;/param&gt;
    /// &lt;returns&gt;返回结束ip的数值&lt;/returns&gt;
    private uint GetEndIp(uint left)
    {
        long left_offset = firstStartIpOffset + (left * 12);
        return BytesToLong(data[4 + left_offset], data[5 + left_offset], data[6 + left_offset], data[7 + left_offset]);

    }

    /// &lt;summary&gt;
    /// 返回地址信息
    /// &lt;/summary&gt;
    /// &lt;param name="local_offset"&gt;地址信息的流位置&lt;/param&gt;
    /// &lt;param name="local_length"&gt;地址信息的流长度&lt;/param&gt;
    /// &lt;returns&gt;&lt;/returns&gt;
    private string GetLocal(uint local_offset, uint local_length)
    {
        byte[] buf = new byte[local_length];
        Array.Copy(data, local_offset, buf, 0, local_length);
        return Encoding.UTF8.GetString(buf, 0, (int)local_length);

    }

    /// &lt;summary&gt;
    /// 字节转整形 小节序
    /// &lt;/summary&gt;
    /// &lt;param name="a"&gt;&lt;/param&gt;
    /// &lt;param name="b"&gt;&lt;/param&gt;
    /// &lt;param name="c"&gt;&lt;/param&gt;
    /// &lt;param name="d"&gt;&lt;/param&gt;
    /// &lt;returns&gt;&lt;/returns&gt;
    private uint BytesToLong(byte a, byte b, byte c, byte d)
    {
        return ((uint)a &lt;&lt; 0) | ((uint)b &lt;&lt; 8) | ((uint)c &lt;&lt; 16) | ((uint)d &lt;&lt; 24);
    }
}

/*
（调用例子）：
IPSearch finder = new IPSearch("qqzeng-ip.dat");
string result = finder.Query("1.2.3.4");
--&gt; result="亚洲|中国|香港|九龙|油尖旺|新世界电讯|810200|Hong Kong|HK|114.17495|22.327115"
*/

public class PrefixIndex
{
    public uint prefix { get; set; }
    public long start_index { get; set; }
    public long end_index { get; set; }
}

//将来将添加多种语言解析</pre>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-20 10:36:28 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>(原创)高性能IP数据库格式详解 qqzeng-ip.dat的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0Y8ZOwM.html" rel="bookmark">网络层协议介绍，IP包格式详解&plus;ARP原理（重点3，网络小白必备知识）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.我们先回顾一下网络层是我们网络基础七层原理的哪一层是我们的第三层,这个数据包里面有IP头部,TC头部和上层数据二.网络层的功能网路层数据包里面的IP地址相当于我们的逻辑地址,全局地址,在全球当中我们的电脑会被分配到一个地址.三.数据包格式详解版本:我们现在有两个版本IPV4,IPV6,首先我们的IP地址的资源是有限的,我们暂时处于这两个的中间,全球60几亿人.首部长度:就是我们头部格式的长度,不包含上层数据优先级与服务类型:决定什么数据先发送,就比如我们QQ发消息给别人,同时我们还在下载东西			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MmLyaQ4.html" rel="bookmark">IP报文格式详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				下图为常见的IP报文格式表: 上面是IP的报文格式,接下来我们先说明各个字段的意义.然后,用Etheral软件转包分析IP的报文格式. 1.版本:ip报文中,版本占了4位,用来表示该协议采用的是那一个版本的ip,相同版本的ip才能进行通信.一般此处的值为4,表示ipv4. 2.头长度:该字段用四位表示,表示整个ip包头的长度,其中数的单位是4字节.即二进制数0000-1111(十进制数0-15),其中一个最小长度为0字节,最大长度为60字节.一般来说此处的值为0101,表示头长度为20字节. 3			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4NlJR20.html" rel="bookmark">MySQL数据库备份详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:MySQL数据库备份详解 对于任何数据库来说,备份都是非常重要的 数据库复制不能取代备份的作用 比如我们由于误操作,在主数据库上删除了一些数据,由于主从复制的时间很短,在发现时,从数据库上的数据可能也已经被删除了, 我们不能使用从数据库上的数据来恢复主数据库上的数据,只能通过备份进行误删除数据的恢复 一. 备份的分类 1.按备份的结果来分: 逻辑备份 其备份结果为SQL语句,适合于所有存储引擎,恢复时需要较多时间,逻辑备份时,对于MyISAM存储引擎是需要进行锁表操作的,通过使用的mysq			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/9MEjxP0.html" rel="bookmark">OSI七层模型详解    TCP&sol;IP协议</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				总结 OSI中的层 功能 TCP/IP协议族 应用层 文件传输,电子邮件,文件服务,虚拟终端 TFTP,HTTP,SNMP,FTP,SMTP,DNS,Telnet 等等 表示层 数据格式化,代码转换,数据加密 没有协议 会话层 解除或建立与别的接点的联系 没有协议 传输层 提供端对端的接口 TCP,UDP 网络层 为数据包选择路由 IP,ICMP,OSPF,EIGRP,IGMP 数据链路层 传输有地址的帧以及错误检测功能 SLIP,CSLIP,PPP,MTU 物理层 以二进制数据形式在物理媒体上			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0RDQG74.html" rel="bookmark">H2数据库使用 详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				H2最完整的资料下载地址: http://download.csdn.net/detail/yixiaoping/5956595 H2数据库使用 H2数据库介绍 常用的开源数据库:H2,Derby,HSQLDB,MySQL,PostgreSQL.其中H2,HSQLDB类似,十分适合作为嵌入式数据库使用,其它的数据库大部分都需要安装独立的客户端和服务器端.H2的优势:1.h2采用纯Java编写,因此不受平台的限制.2.h2只有一个jar文件,十分适合作为嵌入式数据库试用.3.性能和功能的优势 H2			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3qRwga4.html" rel="bookmark">MySQL数据库优化详解&lpar;收藏&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				MySQL数据库优化详解 mysql表复制 复制表结构+复制表数据mysql&gt; create table t3 like t1;mysql&gt; insert into t3 select * from t1;mysql索引 ALTER TABLE用来创建普通索引.UNIQUE索引或PRIMARY KEY索引ALTER TABLE table_name ADD INDEX index_name (column_list)ALTER TABLE table_name ADD UNIQUE (colu			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MorLEn4.html" rel="bookmark">Oracle数据库备份详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Oracle数据库备份详解 Oracle官方提供多种备份方式,日常使用最多的有exp/imp常规方式,及数据泵expdp/impdp方式:下面对这两种方式进行详解. 常规方式 exp/imp imp/exp是Oracle导入导出命令,可以用作数据的迁移,expdp/imdp也是Oracle数据导入导出的命令,效率比imp/exp效率要高,这个后面再讨论 一  EXP导出命令 exp 是数据的导出命令,可以用于表,用户,整个数据库,exp -help查看帮助 Export: Release 11.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MGL2q60.html" rel="bookmark">数据库视图详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				数据库视图详解 - 定义: 视图(View)是从一个或多个表(或视图)导出的表.视图与表(有时为与视图区别,也称表为基本表--Base Table)不同,视图是一个虚表,即视图所对应的数据不进行实际存储,数据库中只存储视图的定义,在对视图的数据进行操作时,系统根据视图的定义去操作与视图相关联的基本表. 视图就像一个窗口,透过它可以看到数据库中自己感兴趣的数据及其变化 - 视图的创建 SQL Server创建视图的语法: CREATE VIEW [ &lt; database_name &gt; .] [			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3O2j780.html" rel="bookmark">josn格式详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				josn格式详解:!! JSON的全称是”JavaScript Object Notation”,意思是JavaScript对象表示法,它是一种基于文本,独立于语言的轻量级数据交换格式.XML也是一种数据交换格式,为什么没有选择XML呢?因为XML虽然可以作为跨平台的数据交换格式,但是在JS(JavaScript的简写)中处理XML非常不方便,同时XML标记比数据多,增加了交换产生的流量,而JSON没有附加的任何标记,在JS中可作为对象处理,所以我们更倾向于选择JSON来交换数据.这篇文章主要从			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/V02RNn0.html" rel="bookmark" class="title">linux下如何实现mysql数据库每天自动备份定时备份</a>
					<div>
						版权声明:本文为 testcs_dn(微wx笑) 原创文章,非商用自由转载-保持署名-注明出处,谢谢. 目录(?)[+] 概述 ??备份是容灾的基础,是指为防止系统出现操作失误或系统故障导致数据丢失, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXYEPb0.html" rel="bookmark" class="title">16进制串hex与ASCII字符串相互转换</a>
					<div>
						提供两个函数,方便十六进制串与ASCII 字符串之间的相互转换,使用函数需要注意的是返回的串是在堆上通过 calloc 分配的,所以,记得使用完返回值释放该块,并且将指向该块的指针 =NULL . c ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KyAJL4.html" rel="bookmark" class="title">angualarjsdemo</a>
					<div>
						AngularJs学习笔记--Forms 原版地址:http://code.angularjs.org/1.0.2/docs/guide/forms 控件(input.select.textarea) ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0bnAx90.html" rel="bookmark" class="title">JavaScript设计模式与开发实践：分时函数</a>
					<div>
						web端在进行大量DOM数据插入的时候,如果一次性插入上千条数据,浏览器吃不消会出现卡顿假死的情况,代码如下: var arr = []; for(var i = 0; i &lt; 1000; i+ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MomVrP3.html" rel="bookmark" class="title">Xcode 设置Pch文件</a>
					<div>
						Xcode 6将Pch文件移出默认创建文件, 须使用者手动添加, 添加步骤如下: 1. 创建Pch文件 2. 修改Project内 Precompile Prefix Header 设置:Projec ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0x596L3.html" rel="bookmark" class="title">HDU1203 DP-01背包</a>
					<div>
						I NEED A OFFER! Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47mqYy0.html" rel="bookmark" class="title">海滨小城&OpenCurlyDoubleQuote;房事&rdquo;之殇 防城港&OpenCurlyDoubleQuote;看房一日游&rdquo;陷阱</a>
					<div>
						海滨小城“房事”之殇 防城港“看房一日游”陷阱 行业动态华夏时报[微博]陈锋2014-11-16 07:40 我要分享 138 本报记者 陈锋 实习记者 王墁 防城港.北京报道 即便“鬼城”鄂尔多斯, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kZkazM.html" rel="bookmark" class="title">【大数据技术干货】阿里云伏羲&lpar;fuxi&rpar;调度器FuxiMaster功能简介&lpar;三&rpar; 针对在线服务的资源强稳定</a>
					<div>
						免费开通大数据服务:https://www.aliyun.com/product/odps 转载自xingbao 各位好,这是介绍阿里云伏羲(fuxi)调度器系列文章的第三篇,今天主要介绍针对在线服务 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4NqRP63.html" rel="bookmark" class="title">Swift - 使用NSNotificationCenter发送通知，接收通知</a>
					<div>
						1,通知(NSNotification)介绍 这里所说的通知不是指发给用户看的通知消息,而是系统内部进行消息传递的通知.要介绍通知之前,我们需要先了解什么是观察者模式. 观察者模式 (Observer ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPwrN64.html" rel="bookmark" class="title">递归调用函数-以字符串输出数字</a>
					<div>
						递归输出字符,注意,使用putchar输出一个数字的时候需要加'0',否则.... 1 #include&lt;stdio.h&gt; 2 3 void convert(int n) 4 { 5 in ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KZdrLM.html" rel="bookmark" class="title">商业智能（BI）主流正走向大众化（转）</a>
					<div>
						很多人认为商业智能是决策辅助系统.是“老板工程”,属于少数高管和专业分析人员.然而近年来,商业智能“贵族”身份已经不再适合组织内部上下层级纵向扩展商业智能的应用需要,普及化的“全民商业智能”正成为发展 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KZnWmM.html" rel="bookmark" class="title">无线局域网的另外4大问题和解决方法</a>
					<div>
						无线局域网被认为是一种不可靠的网络,除了加强网络管理以外,更需要测试设备的构建.实施.维护和管理 尽管IT的寒冬还未渡过,但WLAN以其便利的安装.使用,高速的接入速度,可移动的接入方式赢得了众多公司 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGRVpy4.html" rel="bookmark" class="title">【iCore3 双核心板&lowbar;视频】视频二：iCore3原理图介绍</a>
					<div>
						iCore3原理图介绍: http://v.youku.com/v_show/id_XMTU3NDk5Njk0MA==.html iCore3 购买链接: https://item.taobao.co ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0eE1Ww0.html" rel="bookmark" class="title">web Form 表单method&equals;&amp;quot&semi;get&amp;quot&semi; method&equals;&amp;quot&semi;post&amp;quot&semi; 区别</a>
					<div>
						get和post方法的不同 在B/S应用程序中,前台与后台的数据交互,都是通过HTML中Form表单完成的.Form提供了两种数据传输的方式——get和post.虽然它们都是数据的提交方式,但是在实际 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nRarP0.html" rel="bookmark" class="title">MVC01</a>
					<div>
						MVC基础知识详情 1:在MVC中如果要从前台页面(.aspx)获取参数,只需要将其两个页面的参数设置成一样的,这样子MVC中的机制就会自动的将参数的值传到方法中. 2:在MVC中的方法要是两个都是相 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4Qoo8l0.html" rel="bookmark" class="title">类型信息</a>
					<div>
						RTTI 运行时类型信息 在Java中.所有的类型转换都是在运行时进行正确性检查的,这也是RTTI的名字含义,在运行时识别一个对象的类型. 而RTTI的另一个重要作用在于,在多态的情况下,保证一个向上 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0e9bVZ0.html" rel="bookmark" class="title">MySQL-Cluster-7&period;4 for centos 6&period;9 64bit</a>
					<div>
						MySQL-Cluster-7.5 for centos 6.9 64bit 一.安装要求 1.安装环境: 系统环境:CentOS release 6.9 64bit  软件名称:MySQL-Clus ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MynwYA0.html" rel="bookmark" class="title">【转】Activity的launchMode分析 及 Intent&period;FLAG&lowbar;NEW&lowbar;TASK详解</a>
					<div>
						Activity的启动模式共有四种,分别如下: 1.standard 2.singleTop 3.singleTask 4.singleInstance 这里我们分两种情况讨论上述四种启动模式:app ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rQnl90.html" rel="bookmark" class="title">爱加密：金融行业网络安全面临&OpenCurlyDoubleQuote;多重考验&rdquo;</a>
					<div>
						互联网的&quot;创新力&quot;令人着迷,它为金融行业实现业务突破.为用户提供最佳服务体验,迎来了无限机会和可能.但在移动支付.云计算.大数据这些全新的应用环境和商业模式下,愈演愈烈的网络威胁却 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38rmOZM.html" rel="bookmark" class="title">apache配置svn&comma;php</a>
					<div>
						apache配置svn环境和php环境 需要准备的工具 apache:http://mirror.bit.edu.cn/apache//httpd/binaries/win32/ svn客户端:htt ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.034 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
